%define pre	%nil

%define _provides_exceptions perl(.*)
%define _requires_exceptions perl(\\(XML::Twig\\|MIME::Parser\\|Bugzilla.*\\|DBD::.*\\|DBI::st\\))

Name:		bugzilla
Version:	4.4.5
Release:	%mkrel 1

Summary:	A bug tracking system developed by mozilla.org
License:	MPL
Group:		Networking/WWW
Url:		http://www.bugzilla.org
Source0:	ftp://ftp.mozilla.org/pub/mozilla.org/webtools/%{name}-%{version}%pre.tar.gz
Source1:	Bugzilla.pm
Patch0:		%{name}-fhs.patch
Patch2:		bugzilla-4.0.2-fix-permissions.patch
Patch3:		bugzilla-4.0.2-recommend-urpmi.patch
Requires:	apache
Requires:	perl(CGI) >= 1:3.510.0
Requires:	perl(Date::Format) >= 2.23
Requires:	perl(DateTime)     >= 0.280.0
Requires:	perl(Digest::SHA)
Requires:       perl(Date::Format) >= 2.23
Requires:	perl(File::Spec)   >= 0.840.0
Requires:	perl(DBI)          >= 1.540.0
Requires:	perl(Template)     >= 2.220.0
Requires:	perl(Email::Send)  >= 2.0.0
Requires:	perl(Email::MIME::Modifier)
Requires:	perl(Math::Random::ISAAC) >= 1.0.1
Requires:	perl(Math::Random::ISAAC::XS)
Requires:       perl(Email::MIME) >= 1.904
Requires:       perl(URI) >= 1.37 
Requires:       perl(List::MoreUtils) >= 0.32 
Requires:	sendmail-command
Suggests:	diffutils
Suggests:	graphviz
Suggests:	patchutils
Suggests:	perl(DBD::mysql) >= 4.0.1
Suggests:	perl(DBD::Pg)    >= 2.7.0
Suggests:	perl(GD)
Suggests:	perl(GD::Graph)
Suggests:	perl(GD::TextUtil)
Suggests:	perl(Chart::Base)
Suggests:	perl(Net::LDAP)
Suggests:	perl(PatchReader)
Suggests:	perl(XML::Parser)
BuildArch:	noarch

%description
Bugzilla is one example of a class of programs called "Defect Tracking
Systems", or, more commonly, "Bug-Tracking Systems". Defect Tracking Systems
allow individual or groups of developers to keep track of outstanding bugs
in their product effectively.

%package contrib
Summary:	Additional tools for %{name}
Group:		Networking/WWW

%description contrib
This package contains additional tools for %{name}.

%prep
%setup -q -n %name-%version%pre
find . -name CVS -o -name .cvsignore | xargs rm -rf

# fix perms
chmod -R go=u-w .
chmod 644 Bugzilla/Bug.pm
chmod 644 template/en/default/admin/keywords/*
chmod 755 docs/makedocs.pl

# fix paths
find . -type f | xargs perl -pi -e "s|/usr/local/bin|%{_bindir}|g"

# fix contrib documentation files names
(cd contrib/bugzilla-submit && mv README README.bugzilla-submit)

%patch0 -p1
%patch2 -p1
%patch3 -p1

%build

%install
rm -rf %{buildroot}

%__mkdir_p %buildroot%perl_sitelib
install -m644 %{SOURCE1} %buildroot%perl_sitelib

install -d -m 755 %{buildroot}%{_datadir}/%{name}

install -d -m 755 %{buildroot}%{_datadir}/%{name}/www
install -m 755 *.cgi %{buildroot}%{_datadir}/%{name}/www
cp -pr js skins images robots.txt %{buildroot}%{_datadir}/%{name}/www
install -d -m 755 %{buildroot}%{_datadir}/%{name}/extensions
install -d -m 755 %{buildroot}%{_datadir}/%{name}/www/skins/custom
install -d -m 755 %{buildroot}%{_datadir}/%{name}/www/skins/contrib

install -d -m 755 %{buildroot}%{_datadir}/%{name}/lib
install -d -m 755 %{buildroot}%{_datadir}/%{name}/bin

# only install english templates (bug #61555)
install -d -m 755 %{buildroot}%{_datadir}/%{name}/template
cp -pr template/en %{buildroot}%{_datadir}/%{name}/template

cp -pr Bugzilla %{buildroot}%{_datadir}/%{name}/lib
install -m 644 Bugzilla.pm \
	%{buildroot}%{_datadir}/%{name}/lib
install -m 755 collectstats.pl \
	testserver.pl \
	checksetup.pl \
	importxml.pl \
	whineatnews.pl \
	whine.pl \
	contrib/bzdbcopy.pl \
	contrib/cvs-update.pl \
	contrib/jb2bz.py \
	contrib/merge-users.pl \
	contrib/mysqld-watcher.pl \
	contrib/sendbugmail.pl \
	contrib/sendunsentbugmail.pl \
	contrib/syncLDAP.pl \
	contrib/bugzilla-submit/bugzilla-submit \
	contrib/cmdline/buglist \
	contrib/cmdline/bugs \
	%{buildroot}%{_datadir}/%{name}/bin

install -d -m 755 %{buildroot}%{_localstatedir}/lib/%{name}
install -d -m 755 %{buildroot}%{_sysconfdir}/%{name}
install -m 644 contrib/cmdline/query.conf %{buildroot}%{_sysconfdir}/%{name}

install -d -m 755 %{buildroot}%{_sysconfdir}/%{name}

# apache configuration
install -d -m 755 %{buildroot}%{_webappconfdir}
cat > %{buildroot}%{_webappconfdir}/%{name}.conf <<EOF
# Bugzilla Apache configuration
Alias /bugzilla/data %{_localstatedir}/lib/bugzilla/
Alias /%{name} %{_datadir}/%{name}/www

<Directory %{_datadir}/%{name}/www>
    Require all granted

    Options ExecCGI
    DirectoryIndex index.cgi
    AddHandler cgi-script .cgi .pl
</Directory>

# The dot files must be accessible to the public webdot server
# The png files locally created locally must be accessible
<Directory %{_localstatedir}/lib/bugzilla/webdot>
    <FilesMatch \.dot$>
        Require host research.att.com
    </FilesMatch>

    <FilesMatch \.png$>
        Require all granted
    </FilesMatch>
</Directory>
EOF

# cron task
install -d -m 755 %{buildroot}%{_sysconfdir}/cron.d
cat > %{buildroot}%{_sysconfdir}/cron.d/%{name} <<EOF
0 0 * * *     apache     %{_datadir}/%{name}/bin/collectstats.pl > /dev/null 2>&1
0 0 * * *     apache     %{_datadir}/%{name}/bin/whineatnews.pl > /dev/null 2>&1
*/15 * * * *  apache     %{_datadir}/%{name}/bin/whine.pl > /dev/null 2>&1
EOF

cat > README.urpmi <<EOF
Mageia RPM specific notes

setup
-----
The setup used here differs from default one, to achieve better FHS compliance.
- the constant files are in %{_datadir}/%{name}
- the variables files are in %{_localstatedir}/lib/%{name}
- the configuration file will be generated in %{_sysconfdir}/%{name}

post-installation
-----------------
 - create a database in one of: MySQL/MariaDB/PostgreSQL
 - run %{_datadir}/%{name}/bin/checksetup.pl

Additional useful packages
--------------------------
- perl-GD, perl-GDGraph, perl-GD-TextUtil and perl-Chart for graphical reports
- perl-XML-Parser for importing XML bugs
- perl-Net-LDAP for LDAP authentication
- perl-PatchReader, cvs, diffutils and patchutils for patch viewer
- graphviz for graphical view of dependency relationships
- a MySQL/MariaDB/PostgreSQL database, either locale or remote
EOF

%files
%doc README README.urpmi docs
%config(noreplace) %{_webappconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/cron.d/%{name}
%{_datadir}/%{name}
%{_sysconfdir}/%{name}
%attr(-,apache,apache) %{_localstatedir}/lib/%{name}
%perl_sitelib/*
%exclude %{_datadir}/%{name}/bin/cvs-update.pl
%exclude %{_datadir}/%{name}/bin/jb2bz.py
%exclude %{_datadir}/%{name}/bin/mysqld-watcher.pl
%exclude %{_datadir}/%{name}/bin/sendbugmail.pl
%exclude %{_datadir}/%{name}/bin/sendunsentbugmail.pl
%exclude %{_datadir}/%{name}/bin/syncLDAP.pl
%exclude %{_datadir}/%{name}/bin/bugzilla-submit
%exclude %{_datadir}/%{name}/bin/buglist
%exclude %{_datadir}/%{name}/bin/bugs
%exclude %{_sysconfdir}/%{name}/query.conf

%files contrib
%doc contrib/README
%doc contrib/bugzilla-submit/README.bugzilla-submit
%{_datadir}/%{name}/bin/cvs-update.pl
%{_datadir}/%{name}/bin/jb2bz.py
%{_datadir}/%{name}/bin/mysqld-watcher.pl
%{_datadir}/%{name}/bin/sendbugmail.pl
%{_datadir}/%{name}/bin/sendunsentbugmail.pl
%{_datadir}/%{name}/bin/syncLDAP.pl
%{_datadir}/%{name}/bin/bugzilla-submit
%{_datadir}/%{name}/bin/buglist
%{_datadir}/%{name}/bin/bugs
%config(noreplace) %{_sysconfdir}/%{name}/query.conf

#--------------------------------------------------------------------



%changelog
* Tue Aug 12 2014 luigiwalser <luigiwalser> 4.4.5-1.mga4
+ Revision: 662122
- 4.4.5 (fixes CVE-2014-1546)

  + tmb <tmb>
    - enable cgi-script handler
    - sync fhs patch
    - update to 4.4.4 (CVE fixes)

* Sat Oct 19 2013 umeabot <umeabot> 4.4.1-2.mga4
+ Revision: 526523
- Mageia 4 Mass Rebuild

* Thu Oct 17 2013 ovitters <ovitters> 4.4.1-1.mga4
+ Revision: 502183
- new version 4.4.1

* Tue Jun 04 2013 dmorgan <dmorgan> 4.4-1.mga4
+ Revision: 437226
- New version

* Wed Feb 20 2013 dmorgan <dmorgan> 4.4-0.rc2.3.mga3
+ Revision: 399542
- Add more versions
- Update needed deps
- New version

  + oden <oden>
    - 4.2.5 (fixes CVE-2013-0785, CVE-2013-0786)
    - 4.2.4 (fixes CVE-2012-4199,4198,4189,4197,5475)

* Fri Jan 11 2013 umeabot <umeabot> 4.2.3-4.mga3
+ Revision: 347218
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Sep 08 2012 guillomovitch <guillomovitch> 4.2.3-3.mga3
+ Revision: 290479
- make webapp configuration file compatible with apache 2.4

* Thu Aug 30 2012 ovitters <ovitters> 4.2.3-2.mga3
+ Revision: 285919
- bump release to ensure higher than Mageia 2 updates version

* Thu Aug 30 2012 ovitters <ovitters> 4.2.3-1.mga3
+ Revision: 285903
- new version 4.2.3

* Tue Aug 07 2012 guillomovitch <guillomovitch> 4.2.2-1.mga3
+ Revision: 279830
- new version

* Sun Aug 05 2012 ovitters <ovitters> 4.2.1-2.mga3
+ Revision: 278582
- fix requires (mga#6093)

* Sun Apr 29 2012 fwang <fwang> 4.2.1-1.mga2
+ Revision: 234164
- new version 4.2.1

* Sat Feb 25 2012 ovitters <ovitters> 4.2-3.mga2
+ Revision: 214705
- make README.urpmi work
- don't only suggest MySQL, also mention MariaDB+PostgreSQL

* Sat Feb 25 2012 ovitters <ovitters> 4.2-2.mga2
+ Revision: 214656
- make bugzilla actually work (mga#4676)

* Wed Feb 22 2012 ovitters <ovitters> 4.2-1.mga2
+ Revision: 212425
- update file list
- fix accidental tabs
- new version
- update patch0

* Wed Feb 22 2012 ovitters <ovitters> 4.0.5-2.mga2
+ Revision: 212401
- new version

* Wed Feb 01 2012 ovitters <ovitters> 4.0.4-2.mga2
+ Revision: 203853
- new version
- drop jsonrpc patch
- retab! spec file

  + guillomovitch <guillomovitch>
    - keep %%files sections at the end of file

* Sun Jan 01 2012 ovitters <ovitters> 4.0.3-2.mga2
+ Revision: 189444
- add patch for new perl-JSON-RPC (mga#3906)

* Thu Dec 29 2011 ovitters <ovitters> 4.0.3-1.mga2
+ Revision: 188612
- new version 4.0.3
- drop patch1 (merged)

* Mon Sep 19 2011 ovitters <ovitters> 4.0.2-8.mga2
+ Revision: 145611
- ensure release is newer than 1

* Sun Sep 18 2011 ovitters <ovitters> 4.0.2-7.mga2
+ Revision: 145108
- add patch to ensure optional dependencies are installed using urpmi

* Sun Sep 18 2011 ovitters <ovitters> 4.0.2-6.mga2
+ Revision: 144986
- remove duplicates.rdf apache config as upstream removed it in 3.4

* Sun Sep 18 2011 ovitters <ovitters> 4.0.2-5.mga2
+ Revision: 144980
- add patch to make checksetup.pl work (bug 1040)

* Sun Sep 18 2011 ovitters <ovitters> 4.0.2-4.mga2
+ Revision: 144954
- update Bugzilla.pm file to make it work with mod_perl
  update fhs patch per suggestions upstream

  + dmorgan <dmorgan>
    - Fix path in checksetup
      Really remove ruby file
    - Fix path to bugzilla ( mga #1040)
    - we remove bugzilla_ldapsync.rb because it does not work and add dep on ruby ( mga #1776)
    - Add upstream patch to fix a check with new perl-version
    - Fix $bz_root_dir thanks to LpSolit
    - New version  4.0.2
      Add Upstream Bugzilla.pm ( allow to remove P2 )

* Fri Feb 18 2011 dmorgan <dmorgan> 4.0-1.mga1
+ Revision: 53387
- New version 4.0

* Fri Feb 04 2011 dmorgan <dmorgan> 4.0-0.rc2.1.mga1
+ Revision: 46840
- Update to bugzilla 4.0 RC2
- imported package bugzilla

